!****h* src/module/constante
! NAME
!
!  Module constante
!
! USAGE
!
!  use constante
!
! DESCRIPTION
!
!  This module is used to get the values of the different constants
!
! OUTPUT
!
!  This module exports 10 parameters
!  * pi -- a real (type ki), pi
!  * gammae -- a real (type ki), the Euler constant
!  * i_ -- a complex (type ki), the square root of -1
!  * pi3 -- a real (type ki), pi**2/3
!  * pi6 -- a real (type ki), pi**2/6
!  * pi12 -- a real (type ki), pi**2/12
!  * un -- a real (type ki), 1
!  * zero -- a real (type ki), 0
!  * czero -- a complex (type ki), (0,0)
!  * cun -- a complex (type ki), (1,0)
!  * b_null -- an integer 0
!  * s_null -- an array with shape 0
!  * nullarray -- the same as s_null !!!!!!
!
! USES
!
!  * precision (src/module/preci_double.f90)
!
!*****
module constante
  !
  use precision
  implicit none
  !
   real(ki), parameter :: pi = 3.1415926535897932384626433832795028841971693993751_ki
   real(ki), parameter :: gammae = 0.5772156649015328606065120900824024310421593359399_ki
  complex(ki), parameter :: i_ = (0._ki,1._ki)
  real(ki), parameter :: pi3 = pi**2/3._ki, pi6 = pi**2/6._ki, &
                                  pi12 = pi**2/12._ki
  real(ki), parameter :: un = 1._ki, zero = 0._ki
  complex(ki), parameter  :: czero = (0._ki,0._ki), cun = (1._ki,0._ki)
  integer, parameter :: b_null = 0
  integer, dimension(0), parameter :: s_null = 0
  integer, dimension(0), parameter :: nullarray = 0
  !
end module constante
