c produces random momenta and saves them into a math file and a .dat file
c
      implicit real*8 (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      dimension xm(100),p(4,100),q(4,2)
   
c number of rambo calls 
      itermax=10
      
c nlegs is total number of external legs
ccccccccccccccccccccccccccccccccccccccc 
      nlegs=4
ccccccccccccccccccccccccccccccccccccccc      
      
      nbmom=nlegs-2
      
c sqrt of s
      rs = 1000.d0

c      open(8,file='momenta.m')
      open(9,file='momenta.dat')

      wt=0d0
      ifail=0

c loop over itermax different kinematic points
      do i=1,itermax
        write(6,*) " (* ********** momentum set ",i," ********** *) "
c       write(8,*) " (* ********** momentum set ",i," ********** *) "
c
c for nlegs > 3: define q1 and q2 in CMS (x,y,z,E)

      if(nlegs.gt.3) then
  
      q(1,1)= 0.5d0*rs
      q(2,1)= 0.d0
      q(3,1)= 0.d0
      q(4,1)= 0.5d0*rs
      q(1,2)=-0.5d0*rs
      q(2,2)= 0.d0
      q(3,2)= 0.d0
      q(4,2)= 0.5d0*rs
      
c massless:   
      do l=1,nbmom
      xm(l)=0d0
      enddo
c  masses:   
      xm(1)=175.d0
      xm(2)=175.d0
c      xm(3)=175.d0
c      xm(4)=175.d0
c      xm(5)=0.05d0
c      xm(6)=0.d0
       do l=3,nlegs
       xm(l)=0.d0
       enddo
      
c write the two initial state momenta to file
         do j=1,2
c          write(8,*)"       p[",ii,",",j,"]=",q(ii,j),";"
           write(6,101) (q(ii,j),ii=1,4)
           write(9,101) (q(ii,j),ii=1,4)
         enddo

         call rambo(nbmom,rs,xm,p,wt)
c ii labels momentum components, 
c j labels different momenta (up to 100)     

c rambo ordering is (x,y,z,E), do relabelling to (E,x,y,z) only in golem files
c  change sign such that sum_{i=1}^N p_i = 0
         do j=3,nlegs
	 k=j-2
c          write(8,*)"       p[",ii+1,",",j,"]=",-p(ii,k),";"
           write(6,*) (-p(ii,k), ii=1,4)
           write(9,101) (-p(ii,k), ii=1,4)
         enddo	
      
      else ! case nlegs <=3
      
c  masses:   
        xm(1)=0.1d0
        xm(2)=0.3d0
        xm(3)=0.d0
        call rambo(nlegs,rs,xm,p,wt)
         do k=1,nlegs
          write(6,101) (p(ii,k), ii=1,4)
          write(9,101) (p(ii,k), ii=1,4)
        enddo
	
      endif     ! end if nlegs>3  
      
      enddo	! end loop over i=1,itermax

c      close(8)
      close(9)
  101    format(4f17.10)  
  102    format(3f16.10)  
  103    format(f16.10)  
   11 format(1I5)
   12 format(10F17.10)
   13 format(I9,I9,4I5)
      stop
      end
*      
******************************************************************** 
*  RAMBO 
********************************************************************
      subroutine rambo(n,et,xm,p,wt)
c------------------------------------------------------
c
c                       rambo
c
c    ra(ndom)  m(omenta)  b(eautifully)  o(rganized)
c
c    a democratic multi-particle phase space generator
c    authors:  s.d. ellis,  r. kleiss,  w.j. stirling
c    this is version 1.0 -  written by r. kleiss
c
c    n  = number of particles (>1, in this version <101)
c    et = total centre-of-mass energy
c    xm = particle masses ( dim=100 )
c    p  = particle momenta ( dim=(4,100) )
c    wt = weight of the event
c
c------------------------------------------------------
      implicit real*8(a-h,o-z)
      dimension xm(100),p(4,100),q(4,100),z(100),r(4),
     .   b(3),p2(100),xm2(100),e(100),v(100),iwarn(5)
      data acc/1.d-14/,itmax/6/,ibegin/0/,iwarn/5*0/
c
c initialization step: factorials for the phase space weight
      if(ibegin.ne.0) goto 103
      ibegin=1
      twopi=8.*datan(1.d0)
      po2log=dlog(twopi/4.)
      z(2)=po2log
      do 101 k=3,100
  101 z(k)=z(k-1)+po2log-2.*dlog(dfloat(k-2))
      do 102 k=3,100
  102 z(k)=(z(k)-dlog(dfloat(k-1)))
c
c check on the number of particles
  103 if(n.gt.1.and.n.lt.101) goto 104
      print 1001,n
      stop
c
c check whether total energy is sufficient; count nonzero masses
  104 xmt=0.
      nm=0
      do 105 i=1,n
      if(xm(i).ne.0.d0) nm=nm+1
  105 xmt=xmt+dabs(xm(i))
      if(xmt.le.et) goto 201
      print 1002,xmt,et
      stop
c
c the parameter values are now accepted
c
c generate n massless momenta in infinite phase space
  201 do 202 i=1,n
      rrn=rn(1)
      c=2.*rrn-1.
      s=dsqrt(1.-c*c)
      rrn=rn(2)
      f=twopi*rrn
      rrn1=rn(3)
      rrn2=rn(4)
      q(4,i)=-dlog(rrn1*rrn2)
      q(3,i)=q(4,i)*c
      q(2,i)=q(4,i)*s*dcos(f)
  202 q(1,i)=q(4,i)*s*dsin(f)
c
c calculate the parameters of the conformal transformation
      do 203 i=1,4
  203 r(i)=0.
      do 204 i=1,n
      do 204 k=1,4
  204 r(k)=r(k)+q(k,i)
      rmas=dsqrt(r(4)**2-r(3)**2-r(2)**2-r(1)**2)
      do 205 k=1,3
  205 b(k)=-r(k)/rmas
      g=r(4)/rmas
      a=1./(1.+g)
      x=et/rmas
c
c transform the q's conformally into the p's
      do 207 i=1,n
      bq=b(1)*q(1,i)+b(2)*q(2,i)+b(3)*q(3,i)
      do 206 k=1,3
  206 p(k,i)=x*(q(k,i)+b(k)*(q(4,i)+a*bq))
  207 p(4,i)=x*(g*q(4,i)+bq)
c
c calculate weight and possible warnings
      wt=po2log
      if(n.ne.2) wt=(2.*n-4.)*dlog(et)+z(n)
      if(wt.ge.-180.d0) goto 208
      if(iwarn(1).le.5) print 1004,wt
      iwarn(1)=iwarn(1)+1
  208 if(wt.le. 174.d0) goto 209
      if(iwarn(2).le.5) print 1005,wt
      iwarn(2)=iwarn(2)+1
c
c return for weighted massless momenta
  209 if(nm.ne.0) goto 210
      wt=dexp(wt)
      return
c
c massive particles: rescale the momenta by a factor x
  210 xmax=dsqrt(1.-(xmt/et)**2)
      do 301 i=1,n
      xm2(i)=xm(i)**2
  301 p2(i)=p(4,i)**2
      iter=0
      x=xmax
      accu=et*acc
  302 f0=-et
      g0=0.
      x2=x*x
      do 303 i=1,n
      e(i)=dsqrt(xm2(i)+x2*p2(i))
      f0=f0+e(i)
  303 g0=g0+p2(i)/e(i)
      if(dabs(f0).le.accu) goto 305
      iter=iter+1
      if(iter.le.itmax) goto 304
      print 1006,itmax
      goto 305
  304 x=x-f0/(x*g0)
      goto 302
  305 do 307 i=1,n
      v(i)=x*p(4,i)
      do 306 k=1,3
  306 p(k,i)=x*p(k,i)
  307 p(4,i)=e(i)
c
c calculate the mass-effect weight factor
      wt2=1.
      wt3=0.
      do 308 i=1,n
      wt2=wt2*v(i)/e(i)
  308 wt3=wt3+v(i)**2/e(i)
      wtm=(2.*n-3.)*dlog(x)+dlog(wt2/wt3*et)
c
c return for  weighted massive momenta
      wt=wt+wtm
      if(wt.ge.-180.d0) goto 309
      if(iwarn(3).le.5) print 1004,wt
      iwarn(3)=iwarn(3)+1
  309 if(wt.le. 174.d0) goto 310
      if(iwarn(4).le.5) print 1005,wt
      iwarn(4)=iwarn(4)+1
  310 wt=dexp(wt)
      return
c
 1001 format(' rambo fails: # of particles =',i5,' is not allowed')
 1002 format(' rambo fails: total mass =',d15.6,' is not',
     . ' smaller than total energy =',d15.6)
 1004 format(' rambo warns: weight = exp(',f20.9,') may underflow')
 1005 format(' rambo warns: weight = exp(',f20.9,') may  overflow')
 1006 format(' rambo warns:',i3,' iterations did not give the',
     . ' desired accuracy =',d15.6)
      end
***************************************************************
*
*
* random number generator
*
      function rn(idummy)
      real*8 rn,ran
      common/rseeds/i1,i2
      save init
      data init /1/
      i1=3823
      i2=8151
      if (init.eq.1) then
        init=0
*        read(*,*)i1,i2
c        write(*,*) '* seeding with (',i1,',',i2,')'
        call rmarin(i1,i2)
      end if
*
  10  call ranmar(ran)
      if (ran.lt.1d-16) goto 10
      rn=ran
*
      end
*
      subroutine ranmar(rvec)
*     -----------------
* universal random number generator proposed by marsaglia and zaman
* in report fsu-scri-87-50
* in this version rvec is a double precision variable.
      implicit real*8(a-h,o-z)
      common/ raset1 / ranu(97),ranc,rancd,rancm
      common/ raset2 / iranmr,jranmr
      save /raset1/,/raset2/
      uni = ranu(iranmr) - ranu(jranmr)
      if(uni .lt. 0d0) uni = uni + 1d0
      ranu(iranmr) = uni
      iranmr = iranmr - 1
      jranmr = jranmr - 1
      if(iranmr .eq. 0) iranmr = 97
      if(jranmr .eq. 0) jranmr = 97
      ranc = ranc - rancd
      if(ranc .lt. 0d0) ranc = ranc + rancm
      uni = uni - ranc
      if(uni .lt. 0d0) uni = uni + 1d0
      rvec = uni
      end
 
      subroutine rmarin(ij,kl)
*     -----------------
* initializing routine for ranmar, must be called before generating
* any pseudorandom numbers with ranmar. the input values should be in
* the ranges 0<=ij<=31328 ; 0<=kl<=30081
      implicit real*8(a-h,o-z)
      common/ raset1 / ranu(97),ranc,rancd,rancm
      common/ raset2 / iranmr,jranmr
      save /raset1/,/raset2/
* this shows correspondence between the simplified input seeds ij, kl
* and the original marsaglia-zaman seeds i,j,k,l.
* to get the standard values in the marsaglia-zaman paper (i=12,j=34
* k=56,l=78) put ij=1802, kl=9373
      i = mod( ij/177 , 177 ) + 2
      j = mod( ij     , 177 ) + 2
      k = mod( kl/169 , 178 ) + 1
      l = mod( kl     , 169 )
      do 300 ii = 1 , 97
        s =  0d0
        t = .5d0
        do 200 jj = 1 , 24
          m = mod( mod(i*j,179)*k , 179 )
          i = j
          j = k
          k = m
          l = mod( 53*l+1 , 169 )
          if(mod(l*m,64) .ge. 32) s = s + t
          t = .5d0*t
  200   continue
        ranu(ii) = s
  300 continue
      ranc  =   362436d0 / 16777216d0
      rancd =  7654321d0 / 16777216d0
      rancm = 16777213d0 / 16777216d0
      iranmr = 97
      jranmr = 33
      end
       double precision function rnnew(dummy)
*
*      random number function taken from knuth
*      (seminumerical algorithms).
*      method is x(n)=mod(x(n-55)-x(n-24),1/fmodul)
*      no provision yet for control over the seed number.
*
*      ranf gives one random number between 0 and 1.
*      irn55 generates 55 random numbers between 0 and 1/fmodul.
*      in55  initializes the 55 numbers and warms up the sequence.
*
       implicit double precision (a-h,o-z)
       parameter (fmodul=1.d-09)
       integer ia(55)
       save ia
       data ncall/0/
       data mcall/55/
       if( ncall.eq.0 ) then
           call in55 ( ia,234612947 )
           ncall = 1
       endif
       if ( mcall.eq.0 ) then
           call irn55(ia)
           mcall=55
       endif
       rnnew=ia(mcall)*fmodul
       mcall=mcall-1
       end

       subroutine in55(ia,ix)
       parameter (modulo=1000000000)
       integer ia(55)
       ia(55)=ix
       j=ix
       k=1
       do 10 i=1,54
       ii=mod(21*i,55)
       ia(ii)=k
       k=j-k
       if(k.lt.0)k=k+modulo
       j=ia(ii)
   10  continue
       do 20 i=1,10
       call irn55(ia)
   20  continue
       end

       subroutine irn55(ia)
       parameter (modulo=1000000000)
       integer ia(55)
       do 10 i=1,24
       j=ia(i)-ia(i+31)
       if(j.lt.0)j=j+modulo
       ia(i)=j
   10  continue
       do 20 i=25,55
       j=ia(i)-ia(i-24)
       if(j.lt.0)j=j+modulo
       ia(i)=j
   20  continue
       end
************************************************************************
*
      function dot(a,b)
      implicit real*8(a-h,o-z)
      dimension a(4),b(4)
      dot=a(4)*b(4)-a(1)*b(1)-a(2)*b(2)-a(3)*b(3)
      return
      end

 
